///////////////////////////////////////////////////////////
// Práctica Divide y Vencerás y análisis de algoritmos   //
// Version 2012                                          //
// Algoritmos y Estructuras de Datos II, 2o GII          //
// Universidad de Murcia, GinesGM                        //
///////////////////////////////////////////////////////////

#include <string.h>   // Funcion memset
#include <iostream>   // E/S con cin y cout
using namespace std;

#define MAX 2048
// Para simplificar, fijamos un tamaño maximo de 2000x2000

///////////////////////////////////////////////////////////
//////////        VARIABLES GLOBALES        ///////////////
///////////////////////////////////////////////////////////

int A[MAX][MAX];    // Primera matriz de entrada
int B[MAX][MAX];    // Segunda matriz de entrada
int R[MAX][MAX];    // Matriz resultante
int N;              // Tamaño de las matrices


///////////////////////////////////////////////////////////
//////////     FUNCIONES DEL PROGRAMA       ///////////////
///////////////////////////////////////////////////////////

void lee (int M[MAX][MAX])
// Procedimiento para leer una matriz desde la entrada estandar
//   M - matriz donde se van a introducir los datos
{
  for (int i= 0; i<N; i++)
    for (int j= 0; j<N; j++)
      cin >> M[i][j];
}

void multiDirecto (int a, int b, int c, int d, int e, int f)
// Multiplicacion de dos trozos de las matrices A y B por el metodo
// directo, almacenando el resultado en R. Las tres matrices son globales.
//   a, b - fila inicial y final de A, respectivamente
//   c, d - columna inicial y final de A (=fila inicial y final de B)
//   e, f - columna inicial y final de B, respectivamente
{
  int i, j, k, r;
  for (i= a; i<=b; i++)
    for (j= e; j<=f; j++) {
      r= 0;
      for (k= c; k<=d; k++)
        r+= A[i][k]*B[k][j];
      R[i][j]+= r;
    }
}

void multiDVBasico (int a, int b, int c, int d, int e, int f)
// Multiplicacion de dos trozos de las matrices A y B por divide y
// venceras, almacenando el resultado en R. Las tres matrices son globales.
//   a, b - fila inicial y final de A, respectivamente
//   c, d - columna inicial y final de A (=fila inicial y final de B)
//   e, f - columna inicial y final de B, respectivamente
{
  int ab, cd, ef;
  if (a+1>=b || c+1>=d || e+1>=f)  // Si el tamaño es pequeño, caso base
    multiDirecto(a, b, c, d, e, f);
  else {                           // Si no, el caso general
    ab= (a+b)/2;
    cd= (c+d)/2;
    ef= (e+f)/2;
    multiDVBasico(a, ab, c, cd, e, ef);       // Subproblema: A11*B11
    multiDVBasico(a, ab, cd+1, d, e, ef);     // Subproblema: A12*B21
    multiDVBasico(a, ab, c, cd, ef+1, f);     // Subproblema: A11*B12
    multiDVBasico(a, ab, cd+1, d, ef+1, f);   // Subproblema: A12*B22
    multiDVBasico(ab+1, b, c, cd, e, ef);     // Subproblema: A21*B11
    multiDVBasico(ab+1, b, cd+1, d, e, ef);   // Subproblema: A22*B21
    multiDVBasico(ab+1, b, c, cd, ef+1, f);   // Subproblema: A21*B12
    multiDVBasico(ab+1, b, cd+1, d, ef+1, f); // Subproblema: A22*B22
  }
}

void escribe (int M[MAX][MAX])
// Procedimiento para escribir una matriz en la salida estandar
//   M - matriz que se va a escribir
{
  for (int i= 0; i<N; i++)
    for (int j= 0; j<N; j++) {
      cout << M[i][j];
      if (j<N-1) cout << " ";
      else cout << endl;
    }
}

///////////////////////////////////////////////////////////
//////////        PROGRAMA PRINCIPAL        ///////////////
///////////////////////////////////////////////////////////

int main (void)
{
  int T;
  cin >> T;
  for (int i= 0; i<T; i++) {
    cin >> N;
    lee(A);
    lee(B);
    memset(R, 0, sizeof(R));
    multiDVBasico(0, N-1, 0, N-1, 0, N-1);
    // Da lo mismo que:
    // multiDirecto(0, N-1, 0, N-1, 0, N-1);
    escribe(R);
  }
}
